/**************************************************************************
 *                                                                        *
 *   Copyright (c) Digital Equipment  Corporation,  1991.   All  Rights   *
 *   Reserved.  Unpublished rights reserved under the copyright laws of   *
 *   the United States.                                                   *
 *                                                                        *
 *   The software  contained  on  this  media  is  proprietary  to  and   *
 *   embodies   the   confidential   technology  of  Digital  Equipment   *
 *   Corporation.  Possession, use, duplication or dissemination of the   *
 *   software  and media is authorized only pursuant to a valid written   *
 *   license from Digital Equipment Corporation.                          *
 *                                                                        *
 *   RESTRICTED RIGHTS LEGEND Use, duplication, or  disclosure  by  the   *
 *   U.S.   Government  is  subject  to  restrictions  as  set forth in   *
 *   Subparagraph  (c)(1)(ii)  of  DFARS  252.227-7013,   or   in   FAR   *
 *   52.227-19, as applicable.                                            *
 *                                                                        *
 **************************************************************************/
#ifdef SCCS
static char sccsid[]="@(#)avs_client.c	5.4 Stardent 91/05/07";
#endif
/*
			Copyright (c) 1989 by
			Stardent Computer Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Stardent Computer Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
	This file is under sccs control at Stardent in:
	@phobos/sccs3.p/avs/examples/s.avs_client.c
	
*/
#include <stdio.h>
#include <string.h>
#include <avs/avs.h>
#include <sys/types.h>
#include <sys/errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

static int client_debug = 1;

main(argc, argv)
int argc;
char *argv[];
{
   char buf[1024];
   char *prompt, *c;
   FILE *sock_file;
   extern FILE *AVSbuild_tcp_connection();
   
   sock_file = AVSbuild_tcp_connection(argc,argv);

   prompt = (char*)strdup("client>");

   fputs(prompt, stdout);
   
   /* Loop reading the socket until it is finished */
   while (fgets(buf, 1024, stdin)) {

      /**************************************************/
      /* This would be the place to do your own preprocessing */
      /* Recognize close command after it is sent */

      if (!strncmp(buf,"client_",7)) {
	 int token_len = strlen(buf);

	 if ((c = strchr(buf,' ')) || (c = strchr(buf,'\n')))
	     token_len -= strlen(c);

	 if (!strncmp(buf, "client_close", token_len))
	    break;
      
	 else if (!strncmp(buf,"client_debug_on", token_len)) {
	    client_debug = 1;
	 }
	 else if (!strncmp(buf,"client_debug_off", token_len)) {
	    client_debug = 0;
	 }
	 fputs(prompt, stdout);
      }

      /*****************************************/
      /* Send input to server and interpret results */
      else {
	 /* Send input to the server */
	 fputs(buf, sock_file);
	 fflush(sock_file);

	 /* This would be the place to do your own processing */

	 /* Recognize quit command after it is sent to */
	 if (!strncmp(buf, "quit", 4))
	    break;

	 AVSclient_process_output(sock_file);
	 fputs(prompt, stdout);
      }
   }
   exit(0);
   /*NOTREACHED*/
}

/**********************************************************************
AVSclient_process_output - Interpret the servers responses
   recognizing certain initial 
**********************************************************************/

AVSclient_process_output(sock_file)
FILE *sock_file;
{
   char buf[1024];

   /* Process response from the AVS kernel until completed */
   for (;;) {
      if (!fgets(buf, 1024, sock_file)) {
	 fprintf(stderr, "server disappeared unexpectedly!\n");
	 exit(1);
      }
      /* Recognize Acknowledgement of original command */
      if (!strncmp(buf, AVS_SERVER_ACK, strlen(AVS_SERVER_ACK))) {
	 if (client_debug)
	    fputs(buf, stdout);	 
      }
      /* Figure out the response - recognize success or failure */
      else if (!strncmp(buf, AVS_SERVER_CMD_OK, strlen(AVS_SERVER_CMD_OK))) {
	 if (client_debug) fputs(buf, stdout);
	 return(1);
      }

      else if (!strncmp(buf, AVS_SERVER_CMD_FAIL, strlen(AVS_SERVER_CMD_FAIL))) {
	 if (client_debug) fputs(buf, stdout);
	 return(0);
      }

      /* Echo the output from the kernel */
      else fputs(buf, stdout);
   }
}


/*----------------------------------------------------------------------
Establish the connection on the given port
----------------------------------------------------------------------*/

FILE *
AVSbuild_tcp_connection(argc, argv)
int argc;
char *argv[];
{
   int sock_fd;
   struct sockaddr_in sin;
   struct hostent *hostent;
   char filename[256], portbuf[256], *getenv();
   FILE *fd, *sock_file;
   int port;
   
   if ((sock_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      perror("socket");
      exit(1);
   }
   hostent = gethostbyname("localhost");
   if (!hostent) {
      fprintf(stderr, "No host entry for localhost!\n");
      exit(1);
   }
   sprintf(filename, "/tmp/avs_server.%s",
	   (argc > 1) ? argv[1] : getenv("AVS_SERVER_PROCESS"));

   if ((fd = fopen(filename, "r")) == NULL) {
      fprintf(stderr, "No filename %s\n", filename);
      exit(1);
   }

   fgets(portbuf, 256, fd);
   fclose(fd);
   port = atoi(portbuf);
   if (port == 0) {
      fprintf(stderr, "No port number!\n");
      exit(1);
   }
   sin.sin_family = AF_INET;
   sin.sin_port = htons(port);
   sin.sin_addr.s_addr = htonl(*((int*)(hostent->h_addr)));
   memset(sin.sin_zero, '\0', sizeof(sin.sin_zero));
   
   if (connect(sock_fd, (struct sockaddr *)&sin, sizeof(struct sockaddr_in)) < 0) {
      perror("connect");
      exit(1);
   }
   sock_file = fdopen(sock_fd, "r+");
   setbuf(sock_file, 0);
   return(sock_file);
}

